/*
avltree.h
12/17/04
andrew snowden
*/

#ifndef AVLTREE_H
#define AVLTREE_H

#ifndef NULL
#define NULL ((void *)0)
#endif

typedef struct tag_avl_t avl_t;

typedef struct {
  avl_t *avl;
  int end;
  void *reserved;
  void *data;
} avl_it_t;

typedef int (*avl_cmp_t)(void *, void *, void *);

avl_t *avl_create(avl_cmp_t cmp, void *param);
void avl_destroy(avl_t *avl);
int avl_insert(avl_t *avl, void *data);
int avl_count(avl_t *avl);

void avl_it_init(avl_it_t *it, avl_t *avl);
int avl_it_find(avl_it_t *it, void *data);
int avl_it_first(avl_it_t *it);
int avl_it_last(avl_it_t *it);
int avl_it_next(avl_it_t *it);
int avl_it_prev(avl_it_t *it);
#define avl_it_end(it)  ((it)->end)
#define avl_it_data(it) ((it)->data)

/*
avl_it_find places iterator to spot closest to data
returns 0 on exact match, <0 if current spot is
less than data and >0 if current spot if greater than data

if the tree is empty, iterator is set to null, and -1
is returned.
*/

#endif
