/*
tab-basic.c
andrew snowden

history:
12/30/04 - created tableaux.c from older tableaux.c file
01/23/07 - split off tab-basic.c
*/

#include <malloc.h>
#include <memory.h>
#include <stdlib.h>
#include "avltree.h"
#include "tableaux.h"


int tableau_is_standard(tableau_t *tableau) {
  int i, r, last;

  for (r=0; r<1; r++) {
    last=tableau->row[r][0];
    for (i=1; i<tableau->width; i++) {
      if (tableau->row[r][i]<last) return 0;
      last=tableau->row[r][i];
    }
  }

  for (i=0; i<tableau->width; i++) {
    if (tableau->row[0][i]>=tableau->row[1][i]) return 0;
  }

  return 1;
}

int tableau_is_valid(tableau_t *tableau) {
  int cnt[MAXSIDES], i, x;

  memset(cnt, 0, sizeof(cnt));
  for (i=0; i<tableau->width; i++) {
    x=tableau->row[0][i];
    if (x<1 || x>tableau->sides) return 0;
    cnt[x-1]++;

    x=tableau->row[1][i];
    if (x<1 || x>tableau->sides) return 0;
    cnt[x-1]++;
  }
  for (i=0; i<tableau->sides; i++) {
    if (cnt[i]!=tableau->weight) return 0;
  }
  return 1;
}

tableau_t *tableau_copy(tableau_t *tableau) {
  tableau_t *copy;

  copy=(tableau_t *)malloc(sizeof(tableau_t)+2*tableau->width);
  if (!copy) return NULL;
  memset(copy, 0, sizeof(tableau_t));
  copy->row[0]=(unsigned char *)(copy+1);
  copy->row[1]=copy->row[0]+tableau->width;
  copy->sides=tableau->sides;
  copy->weight=tableau->weight;
  copy->width=tableau->width;
  memcpy(copy->row[0], tableau->row[0], tableau->width);
  memcpy(copy->row[1], tableau->row[1], tableau->width);
  return copy;
}

tableau_t *tableau_create_empty(int sides, int weight) {
  tableau_t *tableau;
  int width;

  width=weight*(sides/2);
  tableau=(tableau_t *)malloc(sizeof(tableau_t)+2*width);
  if (!tableau) return NULL;
  memset(tableau, 0, sizeof(tableau_t));
  tableau->row[0]=(unsigned char *)(tableau+1);
  tableau->row[1]=tableau->row[0]+width;
  tableau->sides=sides;
  tableau->weight=weight;
  tableau->width=width;
  memset(tableau->row[0], 0, width);
  memset(tableau->row[1], 0, width);
  return tableau;
}

void tableau_free(tableau_t *tableau) {
  free(tableau);
}

