/*
tab-list-match.c
01/24/07
andrew snowden
*/

#include "tableaux.h"

static tableau_t *matching, *sqmatching;
static int mode;
static db_t *_db;

static void make_square() {
  int i;

  for (i=0; i<matching->width; i++) {
    sqmatching->row[0][2*i]=matching->row[0][i];
    sqmatching->row[0][2*i+1]=matching->row[0][i];
    sqmatching->row[1][2*i]=matching->row[1][i];
    sqmatching->row[1][2*i+1]=matching->row[1][i];
  }
}

static void output_matching() {
  if (mode==1) {
    db_add(_db, matching);
  } else {
    make_square();
    db_add(_db, sqmatching);
  }
}

static int is_used(int level, int x) {
  int i;

  for (i=0; i<level; i++) {
    if (matching->row[0][i]==x || matching->row[1][i]==x) return 1;
  }
  return 0;
}

static void build_matching(int level) {
  int i, j;

  if (level==matching->width) {
    output_matching();
    return;
  }
  for (j=1; j<=matching->sides && is_used(level, j); j++);
  matching->row[0][level]=j;
  for (i=j+1; i<=matching->sides; i++) {
    if (is_used(level, i)) continue;
    matching->row[1][level]=i;
    build_matching(level+1);
  }
}

void add_matchings(db_t *db, int sides) {
  mode=1;
  _db=db;
  matching=tableau_create_empty(sides, 1);
  build_matching(0);
  tableau_free(matching);
}

void add_squared_matchings(db_t *db, int sides) {
  mode=2;
  _db=db;
  matching=tableau_create_empty(sides, 1);
  sqmatching=tableau_create_empty(sides, 2);
  build_matching(0);
  tableau_free(matching);
  tableau_free(sqmatching);
}
  
