/*
tab-sum.c
andrew snowden

history:
12/30/04 - created tableaux.c from older tableaux.c file
01/23/07 - split off tab-sum.c
*/

#include <malloc.h>
#include <memory.h>
#include <stdlib.h>
#include "avltree.h"
#include "tableaux.h"


sum_t *sum_create() {
  sum_t *sum;

  sum=(sum_t *)malloc(sizeof(sum_t));
  memset(sum, 0, sizeof(sum_t));
  return sum;
}

void sum_free(sum_t *sum) {
  if (sum->id) free(sum->id);
  if (sum->count) free(sum->count);
  free(sum);
}

int sum_add(sum_t *sum, int id, int count) {
  int i;

  for (i=0; i<sum->len; i++) {
    if (sum->id[i]==id) {
      sum->count[i]+=count;
      return 1;
    }
  }
  if (sum->len==sum->alloc) {
    int *tmp;

    tmp=(int *)realloc(sum->count, sizeof(int)*(sum->alloc+16));
    if (!tmp) return 0;
    sum->count=tmp;

    tmp=(int *)realloc(sum->id, sizeof(int)*(sum->alloc+16));
    if (!tmp) return 0;
    sum->id=tmp;

    sum->alloc+=16;
  }
  sum->id[sum->len]=id;
  sum->count[sum->len]=count;
  sum->len++;
  return 1;
}

void sum_simplify(sum_t *sum) {
  int i, j;

  for (i=0, j=0; i<sum->len; i++) {
    if (sum->count[i]==0) continue;
    sum->count[j]=sum->count[i];
    sum->id[j]=sum->id[i];
    j++;
  }
  sum->len=j;
}

